#ifndef FIREWALL_TYPES_H
#define FIREWALL_TYPES_H

#include "stdint.h"

static const uint8_t IPV4ADDRESS_LENGTH = 16;

typedef enum firewall_target : uint8_t
{
    FW_REJECT = 0,
    FW_DROP = 1,
    FW_ACCEPT = 2,
} firewall_target_t;

typedef enum firewall_protocol : uint8_t
{
    FW_TCP = 0,
    FW_UDP = 1,
    FW_ALL = 255,
} firewall_protocol_t;

typedef struct firewall_rule
{
    uint8_t key;
    char source[IPV4ADDRESS_LENGTH];
    char destination[IPV4ADDRESS_LENGTH];
    firewall_protocol_t protocol;
    firewall_target_t target;
    struct firewall_rule *next;
} firewall_rule_t;

#endif
